/*
 *  tester.c
 *  aiousb
 *
 *  Created by Jay Dolan on 3/15/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "aiousb.h"

void doCounters()
{
	int retval;
	int count; 
	UInt16 value;
	
	retval = CTR_8254ModeLoad( 0, 0, 1, 2, 4000);
	if (retval != 0)
		printf("Error ModeLoad\n");
	
	
	retval = CTR_8254ModeLoad( 0, 0, 2, 3, 4000);
	if (retval != 0)
		printf("Error ModeLoad\n");
	
	printf("Outputting frequency on block 0.\n");
	
	for (count = 0; count < 10; count++)
	{
		CTR_8254Read(0 ,0, 1, &value);
		printf("Counter 1: %d\n", value);
		CTR_8254Read(0, 0, 2, &value);
		printf("Counter 2: %d\n\n\n", value);
		sleep(1);
	}
}

void doWrites()
{
	bool done = false;
	
	UInt8 data[4];
	UInt8 byte;
	bool high;
	int choice, index;
	int tInt;
	unsigned int tUnsigned;
	
	do
	{
		printf("1) Write All\n");
		printf("2) Write single ports\n");
		printf("3) Write a single bit\n");
		printf("4) Quit\n");
		printf("=>");
		scanf("%d", &choice);
		
		switch(choice)
		{
			case 1:
				printf("Enter byte =>");
				scanf("%x",  &tUnsigned);
				data[0] = data[1] = tUnsigned;
				DIO_WriteAll(0, data);
				break;
			case 2:
				printf("Enter byte =>");
				scanf("%x", &tUnsigned);
				byte = tUnsigned;
				printf("Enter Index =>");
				scanf("%d", &index);
				DIO_Write8(0, index, &byte);
				break;
			case 3:
				printf("Enter 0 or 1 =>");
				scanf("%d", &tInt);
				high = tInt ? 1 : 0;
				printf("Enter Index =>");
				scanf ("%d", &index);
				DIO_Write1(0, index, &high);
				break;
			case 4:
				done = true;
				break;
		};
	}while (done != true);
}
			

void doReads ()
{
	bool done = false;
	int choice;
	UInt8 data[4] = {0x0, 0x0, 0x5, 0x5};
	UInt8 byte;
	bool high;
	int count;
	
	do
	{
		printf("1) Read All\n");
		printf("2) Read Ports Individually\n");
		printf("3) Read bits Individually\n");
		printf("4) Quit\n");
		printf("=>");
		scanf ("%d", &choice);
		
		
		switch (choice)
		{
			case 1:
				DIO_ReadAll(0, data);
				printf("%4x %4x %4x %4x\n", data[0], data[1], data[2], data[3]);
				break;
			case 2:
				for (count =0; count < 4; count++)
				{
					DIO_Read8(0, count, &byte);
					printf("Port %d: %4x\n", count, byte);
				}
				break;
			case 3:
				for (count = 0; count < 32; count++)
				{
					DIO_Read1(0, count, &high);
					printf("bit %d: %d\n", count, (high ? 1 : 0));
				}
				break;
			case 4:
				done = true;
				break;
		};
	}while (done != true) ;
				
	
}

int main (void)
{
	int numDevices;
	UInt8 bytes[4] = { 0, 0, 0, 0};
	SInt8 retVal;
	
	
	numDevices = queryDevices();

	printf("Devices Found: %d\n", numDevices);
	
	if (numDevices != 0)
	{
		retVal = dioConfig(0, false, 0x0, bytes);
		
		if (retVal == 0)
			printf("dioConfig returned success.\n");
		else
			printf("dioConfig failed.\n");
		
		doReads(); 
		
		dioConfig(0, false, 0xf, bytes);
		
		doWrites();
		
		doCounters();
	}
	
	
	
	return 0;
}

